<template>
	<div class="row">
		<div class="col-2">
			<h2 class="text-principal pb-2">Observaciones</h2>
		</div>
		<div class="col-10 position-relative">
			<div
				class="btn btn-principal mx-2 p-0 position-absolute end-0 me-6"
				role="group"
			>
				<button
					@click="guardar()"
					type="button"
					class="btn btn-principal"
					:disabled="!enableComponent || titulo?.id_estado == 0"
				>
					GUARDAR
				</button>
			</div>
		</div>
		<div class="col-12">
			<textarea
				style="min-height: 110px"
				class="form-control form-control-sm"
				v-model.trim="form.observaciones"
				:disabled="!enableComponent || titulo?.id_estado == 0"
			/>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { Titulo } from "@/entities/Titulo";
import http from "@/http";
import shared from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { AxiosError } from "axios";

const { urlApi, isEmpty } = shared();

export default defineComponent({
	name: "FormularioObservaciones",
	components: {},
	props: {
		titulo: {
			type: Titulo,
			required: false,
			default: undefined,
		},
	},
	data() {
		return {
			form: {
				observaciones: undefined as string | undefined,
			},
		};
	},
	computed: {
		isTitulo() {
			return typeof this.titulo !== "undefined";
		},
	},
	mounted() {},
	methods: {
		async guardar() {
			if (typeof this.titulo === "undefined") {
				Swal.fire({
					icon: "error",
					text: "Debe indicar un título ejecutivo.",
				});
				return false;
			}

			if (isEmpty(this.form.observaciones)) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar una observación.",
				});
				return false;
			}

			try {
				var rta = await http.post(urlApi + "edicionTitulo", {
					accion: "O",
					id_titulo_ejec: this.titulo?.id_titulo_ejec,
					observaciones: this.form?.observaciones,
				});

				if (rta.data.status == "success") {
					Swal.fire({
						icon: "success",
						text: "Se modificaron las observaciónes del título ejecutivo.",
					});
				}
			} catch (error: any) {
				var mensaje: string = error.message;

				if (error instanceof AxiosError) {
					mensaje = error.response?.data.res.mensaje;
				}
				Swal.fire({
					icon: "error",
					text: mensaje,
				});
			}
		},
		enableComponent() {
			if (typeof this.titulo !== "undefined") {
				return this.titulo.id_estado.toString() <= "3";
			}
			return true;
		},
		initForm() {
			this.form.observaciones = undefined;
		},
	},
	watch: {
		titulo() {
			if (typeof this.titulo !== "undefined") {
				this.form.observaciones =
					this.titulo.observaciones != null
						? this.titulo.observaciones
						: undefined;
			}
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
